#!/usr/local/bin/perl
#
#   startproxy.cgi--  Redirect the "URL" input field to use nph-proxy.cgi
#
#   Copyright (C) 1996, 1998 by James Marshall, james@jmarshall.com
#
#   For the latest, see http://www.jmarshall.com/tools/cgiproxy/
#
#   When called from a form with a single field named "URL", it will return
#     a "Location:" header to point the browser through the nph-proxy.cgi
#     script in the correct way, to use PATH_INFO for the URL to be
#     retrieved.
#   Efficiency isn't as critical here as in the main nph-proxy.cgi script,
#     since this is normally called once per browsing session.  Therefore,
#     we should offload as much out of nph-proxy.cgi into this script as
#     possible.
#
#
#   CONFIGURATION:
#     None needed.  If the name of the main script is changed, set 
#       $proxyname below.
#

# If you change the name of the main proxy script, reflect it here.
$proxyname= 'nph-proxy.cgi' ;


# Read the URL from the query input
($ENV{'QUERY_STRING'}=~ /^URL=([^&]*)/)  || &showstartform ;
$URL= $1 ;

# un-encode the URL
$URL=~ s/\+/ /g ;
$URL=~ s/%([\da-fA-F]{2})/pack("c", hex($1))/ge ;

# Warn the user against FTP or other URL's
($scheme)= $URL=~ /^(.[\w+.-]*):/ ;
(($scheme eq '') || ($scheme=~ /^http$/i))
    || &HTMLdie("Sorry, only HTTP browsing is currently supported.") ;

# Support abbreviated URL entries (but only HTTP)
$URL=~ s#^http:##i ;
$URL=~ s#^//##i ;
($host, $port, $path)= ($URL=~ m#([^/:]*)(:?[^/]*)(/.*)?$#) ;
$host= "www.$host.com" unless $host=~ /\./ ;
$path || ($path= "/") ;
$URL= "http://$host$port$path" ;

# Print the Location: header
print "Location: $proxyname/$URL\n\n" ;

exit ;


# Present entry form
sub showstartform {
    print <<EOF ;
Content-type: text/html

<html>
<head>
<title>Start Using CGI Proxy</title>
</head>
<body>

<h1>CGI Proxy</h1>

<p>Start browsing through this CGI-based HTTP proxy by entering a URL
below.  Not all functions will work (e.g. cookies), but most pages will
be fine.

<form action="$ENV{'SCRIPT_NAME'}" method=get>
<input name="URL" size=50>
<p><input type=submit value="   Begin browsing   ">
</form>
<p>
<hr>
<a href="http://www.jmarshall.com/tools/cgiproxy/"><i>CGIProxy 1.0</i></a>
<p>
</body>
</html>
EOF

    exit ;
}


# Die, outputting HTML error page
sub HTMLdie {
    local($msg)= @_ ;
    print <<EOF ;
Content-type: text/html

<html>
<head>
<title>CGI Proxy Error</title>
</head>
<body>
<h1>CGI
 Proxy Error</h1>
<h3>$msg</h3>
<p>
<hr>
<a href="http://www.jmarshall.com/tools/cgiproxy/"><i>CGIProxy 1.0</i></a>
<p>
</body>
</html>
EOF

    exit ;
}
